<?php
/**
 * Automotive Parts functions and definitions
 *
 * @package Automotive Parts
 */

if ( ! defined( 'AUTOMOTIVE_PARTS_VERSION' ) ) {
	// Replace the version number of the theme on each release.
	define( 'AUTOMOTIVE_PARTS_VERSION', '1.0.0' );
}

function automotive_parts_setup() {

	add_theme_support( 'automatic-feed-links' );
	add_theme_support( 'title-tag' );
	add_theme_support( 'post-thumbnails' );
	add_theme_support( 'woocommerce' );
	add_theme_support( "align-wide" );
	add_theme_support( "responsive-embeds" );

	register_nav_menus(
		array(
			'menu-1' => esc_html__( 'Primary', 'automotive-parts' ),
			'social-menu' => esc_html__('Social Menu', 'automotive-parts'),
		)
	);

	add_theme_support(
		'html5',
		array(
			'search-form',
			'comment-form',
			'comment-list',
			'gallery',
			'caption',
			'style',
			'script',
		)
	);

	add_theme_support(
		'custom-background',
		apply_filters(
			'automotive_parts_custom_background_args',
			array(
				'default-color' => '#fafafa',
				'default-image' => '',
			)
		)
	);

	add_theme_support( 'customize-selective-refresh-widgets' );

	add_theme_support(
		'custom-logo',
		array(
			'height'      => 250,
			'width'       => 250,
			'flex-width'  => true,
			'flex-height' => true,
		)
	);

	add_theme_support( 'post-formats', array(
        'image',
        'video',
        'gallery',
        'audio', 
    ));
	
}
add_action( 'after_setup_theme', 'automotive_parts_setup' );

/**
 * Set the content width in pixels, based on the theme's design and stylesheet.
 *
 * Priority 0 to make it available to lower priority callbacks.
 *
 * @global int $automotive_parts_content_width
 */
function automotive_parts_content_width() {
	$GLOBALS['content_width'] = apply_filters( 'automotive_parts_content_width', 640 );
}
add_action( 'after_setup_theme', 'automotive_parts_content_width', 0 );

/**
 * Register widget area.
 *
 * @link https://developer.wordpress.org/themes/functionality/sidebars/#registering-a-sidebar
 */
function automotive_parts_widgets_init() {
	register_sidebar(
		array(
			'name'          => esc_html__( 'Sidebar', 'automotive-parts' ),
			'id'            => 'sidebar-1',
			'description'   => esc_html__( 'Add widgets here.', 'automotive-parts' ),
			'before_widget' => '<section id="%1$s" class="widget %2$s">',
			'after_widget'  => '</section>',
			'before_title'  => '<h2 class="widget-title">',
			'after_title'   => '</h2>',
		)
	);

	register_sidebar(
		array(
			'name'          => esc_html__( 'Footer 1', 'automotive-parts' ),
			'id'            => 'footer-1',
			'description'   => esc_html__( 'Add widgets here.', 'automotive-parts' ),
			'before_widget' => '<section id="%1$s" class="widget %2$s">',
			'after_widget'  => '</section>',
			'before_title'  => '<h2 class="widget-title">',
			'after_title'   => '</h2>',
		)
	);

	register_sidebar(
		array(
			'name'          => esc_html__( 'Footer 2', 'automotive-parts' ),
			'id'            => 'footer-2',
			'description'   => esc_html__( 'Add widgets here.', 'automotive-parts' ),
			'before_widget' => '<section id="%1$s" class="widget %2$s">',
			'after_widget'  => '</section>',
			'before_title'  => '<h2 class="widget-title">',
			'after_title'   => '</h2>',
		)
	);

	register_sidebar(
		array(
			'name'          => esc_html__( 'Footer 3', 'automotive-parts' ),
			'id'            => 'footer-3',
			'description'   => esc_html__( 'Add widgets here.', 'automotive-parts' ),
			'before_widget' => '<section id="%1$s" class="widget %2$s">',
			'after_widget'  => '</section>',
			'before_title'  => '<h2 class="widget-title">',
			'after_title'   => '</h2>',
		)
	);
}
add_action( 'widgets_init', 'automotive_parts_widgets_init' );


function automotive_parts_social_menu()
    {
        if (has_nav_menu('social-menu')) :
            wp_nav_menu(array(
                'theme_location' => 'social-menu',
                'container' => 'ul',
                'menu_class' => 'social-menu menu',
                'menu_id'  => 'menu-social',
            ));
        endif;
    }

/**
 * Enqueue scripts and styles.
 */

function automotive_parts_scripts() {
    // Google Fonts
    $query_args = array(
        'family' => rawurlencode('Poppins:ital,wght@0,100;0,200;0,300;0,400;0,500;0,600;0,700;0,800;0,900;1,100;1,200;1,300;1,400;1,500;1,600;1,700;1,800;1,900'),
        'display' => 'swap',
    );
    wp_enqueue_style('automotive-parts-google-fonts', add_query_arg($query_args, 'https://fonts.googleapis.com/css'), array(), null);

    // Font Awesome CSS
    wp_enqueue_style('font-awesome-5', get_template_directory_uri() . '/revolution/assets/vendors/font-awesome-5/css/all.min.css', array(), '5.15.3');

    // Owl Carousel CSS
    wp_enqueue_style('owl-carousel-style', get_template_directory_uri() . '/revolution/assets/css/owl.carousel.css', array(), wp_get_theme()->get('Version'));

    // Wow script.
	wp_enqueue_script( 'wow-jquery', get_template_directory_uri() . '/revolution/assets/js/wow.js', array('jquery'),'' ,true );
	// Animate CSS
	wp_enqueue_style( 'animate-style', get_template_directory_uri() . '/revolution/assets/css/animate.css' );

    // Main stylesheet
    wp_enqueue_style('automotive-parts-style', get_stylesheet_uri(), array(), wp_get_theme()->get('Version'));

    // Add custom inline styles
    require get_parent_theme_file_path('/custom-style.php');
	wp_add_inline_style('automotive-parts-style', $automotive_parts_custom_css);

    // RTL styles if needed
    if (file_exists(get_stylesheet_directory() . '/rtl.css')) {
        wp_style_add_data('automotive-parts-style', 'rtl', 'replace');
    }

    // Navigation script
    wp_enqueue_script('automotive-parts-navigation', get_template_directory_uri() . '/js/navigation.js', array(), wp_get_theme()->get('Version'), true);

    // Owl Carousel script
    wp_enqueue_script('owl-carousel-jquery', get_template_directory_uri() . '/revolution/assets/js/owl.carousel.js', array('jquery'), wp_get_theme()->get('Version'), true);

    // Custom script
    wp_enqueue_script('automotive-parts-custom-js', get_template_directory_uri() . '/revolution/assets/js/custom.js', array('jquery'), wp_get_theme()->get('Version'), true);

    // Comments reply script
    if (is_singular() && comments_open() && get_option('thread_comments')) {
        wp_enqueue_script('comment-reply');
    }
}
add_action('wp_enqueue_scripts', 'automotive_parts_scripts');

if (!function_exists('automotive_parts_related_post')) :
    /**
     * Display related posts from same category
     *
     */

    function automotive_parts_related_post($post_id){        
        $automotive_parts_categories = get_the_category($post_id);
        if ($automotive_parts_categories) {
            $automotive_parts_category_ids = array();
            $automotive_parts_category = get_category($automotive_parts_category_ids);
            $automotive_parts_categories = get_the_category($post_id);
            foreach ($automotive_parts_categories as $automotive_parts_category) {
                $automotive_parts_category_ids[] = $automotive_parts_category->term_id;
            }
            $automotive_parts_count = $automotive_parts_category->category_count;
            if ($automotive_parts_count > 1) { ?>

         	<?php
		$automotive_parts_related_post_wrap = absint(get_theme_mod('automotive_parts_enable_related_post', 1));
		if($automotive_parts_related_post_wrap == 1){ ?>
                <div class="related-post">
                    
                    <h2 class="post-title"><?php esc_html_e(get_theme_mod('automotive_parts_related_post_text', __('Related Post', 'automotive-parts'))); ?></h2>
                    <?php
                    $automotive_parts_cat_post_args = array(
                        'category__in' => $automotive_parts_category_ids,
                        'post__not_in' => array($post_id),
                        'post_type' => 'post',
                        'posts_per_page' =>  get_theme_mod( 'automotive_parts_related_post_count', '3' ),
                        'post_status' => 'publish',
                        'orderby'           => 'rand',
                        'ignore_sticky_posts' => true
                    );
                    $automotive_parts_featured_query = new WP_Query($automotive_parts_cat_post_args);
                    ?>
                    <div class="rel-post-wrap">
                        <?php
                        if ($automotive_parts_featured_query->have_posts()) :

                        while ($automotive_parts_featured_query->have_posts()) : $automotive_parts_featured_query->the_post();
                            ?>
                            <div class="card-item rel-card-item">
								<div class="card-content">
                                    <?php if ( has_post_thumbnail() ) { ?>
                                        <div class="card-media">
                                            <?php automotive_parts_post_thumbnail(); ?>
                                        </div>
                                    <?php } else {
                                        // Fallback default image
                                        $automotive_parts_default_post_thumbnail = get_template_directory_uri() . '/revolution/assets/images/about1.png';
                                        echo '<img class="default-post-img" src="' . esc_url( $automotive_parts_default_post_thumbnail ) . '" alt="' . esc_attr( get_the_title() ) . '">';
                                    } ?>
									<div class="entry-title">
										<h3>
											<a href="<?php the_permalink() ?>">
												<?php the_title(); ?>
											</a>
										</h3>
									</div>
									<div class="entry-meta">
                                        <?php
                                        automotive_parts_posted_on();
                                        automotive_parts_posted_by();
                                        ?>
                                    </div>
								</div>
							</div>
                        <?php
                        endwhile;
                        ?>
                <?php
                endif;
                wp_reset_postdata();
                ?>
                </div>
                <?php } ?>
                <?php
            }
        }
    }
endif;
add_action('automotive_parts_related_posts', 'automotive_parts_related_post', 10, 1);

/**
 * Checkbox sanitization callback example.
 *
 * Sanitization callback for 'checkbox' type controls. This callback sanitizes `$automotive_parts_checked`
 * as a boolean value, either TRUE or FALSE.
 */
function automotive_parts_sanitize_checkbox($automotive_parts_checked)
{
    // Boolean check.
    return ((isset($automotive_parts_checked) && true == $automotive_parts_checked) ? true : false);
}

/**
 * Implement the Custom Header feature.
 */
require get_template_directory() . '/revolution/inc/custom-header.php';

/**
 * Custom template tags for this theme.
 */
require get_template_directory() . '/revolution/inc/template-tags.php';

/**
 * Functions which enhance the theme by hooking into WordPress.
 */
require get_template_directory() . '/revolution/inc/template-functions.php';

/**
 * Customizer additions.
 */
require get_template_directory() . '/revolution/inc/customizer.php';

/**
 * Breadcrumb File.
 */
require get_template_directory() . '/revolution/inc/breadcrumbs.php';

/**
 * Custom typography options for this theme.
 */
require get_template_directory() . '/revolution/inc/typography-options.php';


//////////////////////////////////////////////   Function for Translation Error   //////////////////////////////////////////////////////
function automotive_parts_enqueue_function() {
		
    /**
    * GET START.
    */
    require get_template_directory() . '/getstarted/automotive_parts_about_page.php';

    /**
    * DEMO IMPORT.
    */
    require get_template_directory() . '/demo-import/automotive_parts_config_file.php';

    define('AUTOMOTIVE_PARTS_FREE_SUPPORT',__('https://wordpress.org/support/theme/automotive-parts/','automotive-parts'));
    define('AUTOMOTIVE_PARTS_PRO_SUPPORT',__('https://www.revolutionwp.com/support/revolution-wp/','automotive-parts'));
    define('AUTOMOTIVE_PARTS_REVIEW',__('https://wordpress.org/support/theme/automotive-parts/reviews/','automotive-parts'));
    define('AUTOMOTIVE_PARTS_BUY_NOW',__('https://www.revolutionwp.com/products/auto-parts-wordpress-theme','automotive-parts'));
    define('AUTOMOTIVE_PARTS_LIVE_DEMO',__('https://demo.revolutionwp.com/automotive-parts-pro/','automotive-parts'));
    define('AUTOMOTIVE_PARTS_PRO_DOC',__('https://demo.revolutionwp.com/wpdocs/automotive-parts-pro/','automotive-parts'));
    define('AUTOMOTIVE_PARTS_LITE_DOC',__('https://demo.revolutionwp.com/wpdocs/automotive-parts-free/','automotive-parts'));
    
}
add_action( 'after_setup_theme', 'automotive_parts_enqueue_function' );


/**
 * Load Jetpack compatibility file.
 */
if ( defined( 'JETPACK__VERSION' ) ) {
	require get_template_directory() . '/revolution/inc/jetpack.php';

}

function automotive_parts_remove_customize_register() {
    global $wp_customize;

    $wp_customize->remove_setting( 'display_header_text' );
    $wp_customize->remove_control( 'display_header_text' );

}

add_action( 'customize_register', 'automotive_parts_remove_customize_register', 11 );

/************************************************************************************/

/**
 * WooCommerce custom filters
 */
add_filter('loop_shop_columns', 'automotive_parts_loop_columns');

if (!function_exists('automotive_parts_loop_columns')) {

	function automotive_parts_loop_columns() {

		$automotive_parts_columns = get_theme_mod( 'automotive_parts_per_columns', 3 );

		return $automotive_parts_columns;
	}
}

/************************************************************************************/

add_filter( 'loop_shop_per_page', 'automotive_parts_per_page', 20 );

function automotive_parts_per_page( $automotive_parts_cols ) {

  	$automotive_parts_cols = get_theme_mod( 'automotive_parts_product_per_page', 9 );

	return $automotive_parts_cols;
}

/************************************************************************************/

add_filter( 'woocommerce_output_related_products_args', 'automotive_parts_products_args' );

function automotive_parts_products_args( $automotive_parts_args ) {

    $automotive_parts_args['posts_per_page'] = get_theme_mod( 'custom_related_products_number', 6 );

    $automotive_parts_args['columns'] = get_theme_mod( 'custom_related_products_number_per_row', 3 );

    return $automotive_parts_args;
}

/************************************************************************************/

/**
 * Custom logo
 */

function automotive_parts_custom_css() {
?>
	<style type="text/css" id="custom-theme-colors" >
        :root {
           
            --automotive_parts_logo_width: <?php echo absint(get_theme_mod('automotive_parts_logo_width')); ?> ;   
        }
        .site-branding img {
            max-width:<?php echo esc_html(get_theme_mod('automotive_parts_logo_width')); ?>px ;    
        }         
	</style>
<?php
}
add_action( 'wp_head', 'automotive_parts_custom_css' );

function automotive_parts_sanitize_choices( $automotive_parts_input, $automotive_parts_setting ) {
    global $wp_customize; 
    $automotive_parts_control = $wp_customize->get_control( $automotive_parts_setting->id ); 
    if ( array_key_exists( $automotive_parts_input, $automotive_parts_control->choices ) ) {
        return $automotive_parts_input;
    } else {
        return $automotive_parts_setting->default;
    }
}

function automotive_parts_sanitize_phone_number( $phone ) {
	return preg_replace( '/[^\d+]/', '', $phone );
}

//Excerpt 
function automotive_parts_excerpt_function($automotive_parts_excerpt_count = 35) {
    $automotive_parts_excerpt = get_the_excerpt();
    $automotive_parts_text_excerpt = wp_strip_all_tags($automotive_parts_excerpt);
    $automotive_parts_excerpt_limit = (int) get_theme_mod('automotive_parts_excerpt_limit', $automotive_parts_excerpt_count);
    $automotive_parts_words = preg_split('/\s+/', $automotive_parts_text_excerpt); 
    $automotive_parts_trimmed_words = array_slice($automotive_parts_words, 0, $automotive_parts_excerpt_limit);
    $automotive_parts_theme_excerpt = implode(' ', $automotive_parts_trimmed_words);

    return $automotive_parts_theme_excerpt;
}


// Add admin notice
function automotive_parts_admin_notice() { 
    global $pagenow;
    $automotive_parts_theme_args      = wp_get_theme();
    $automotive_parts_meta            = get_option( 'automotive_parts_admin_notice' );
    $name            = $automotive_parts_theme_args->__get( 'Name' );
    $automotive_parts_current_screen  = get_current_screen();

    if( !$automotive_parts_meta ){
        if( is_network_admin() ){
            return;
        }

        if( ! current_user_can( 'manage_options' ) ){
            return;
        } 
        
        if( $automotive_parts_current_screen->base !== 'appearance_page_automotive_parts_guide' && 
            $automotive_parts_current_screen->base !== 'toplevel_page_automotiveparts-demoimport' ) { ?>

            <div class="notice notice-success automotive-parts-welcome-notice">
                <p class="automotive-parts-dismiss-link">
                    <strong>
                        <a href="<?php echo esc_url( add_query_arg( 'automotive_parts_admin_notice', '1' ) ); ?>">
                            <?php esc_html_e( 'Dismiss', 'automotive-parts' ); ?>
                        </a>
                    </strong>
                </p>

                <div class="automotive-parts-welcome-notice-wrap">
                    <h2 class="automotive-parts-notice-title">
                        <span class="dashicons dashicons-admin-home"></span> 
                        <?php 
                            $automotive_parts_theme_name = wp_get_theme()->get( 'Name' );
                            /* translators: %s!: Theme Name. */
                            echo esc_html( sprintf( __( 'Welcome to the free theme: %s!', 'automotive-parts' ), $automotive_parts_theme_name ) );
                        ?>
                    </h2>
                    <p class="automotive-parts-notice-desc">
                        <?php esc_html_e( 'Get started by exploring the features of your new theme. Customize your design, add your content, and create a site that fits your vision.', 'automotive-parts' ); ?>
                    </p>

                    <div class="automotive-parts-welcome-info">
                        <div class="automotive-parts-welcome-thumb">
                            <img src="<?php echo esc_url( get_stylesheet_directory_uri() . '/screenshot.png' ); ?>" alt="<?php esc_attr_e( 'Theme Screenshot', 'automotive-parts' ); ?>">
                        </div>

                        <div class="automotive-parts-welcome-import">
                            <h3><span class="dashicons dashicons-download"></span> <?php esc_html_e( 'Quick Start: Import Demo', 'automotive-parts' ); ?></h3>
                            <p><?php esc_html_e( 'Use the Demo Importer to quickly set up your site with a pre-made layout. Get a complete site in minutes.', 'automotive-parts' ); ?></p>
                            <p><a class="button info-link button-primary" href="<?php echo esc_url( admin_url( 'themes.php?page=automotiveparts-demoimport' ) ); ?>"><?php esc_html_e( 'Go to Demo Importer', 'automotive-parts' ); ?></a></p>
                        </div>

                        <div class="automotive-parts-welcome-getting-started">
                            <h3><span class="dashicons dashicons-art"></span> <?php esc_html_e( 'Customize Your Theme', 'automotive-parts' ); ?></h3>
                            <p><?php esc_html_e( 'Want to make it truly yours? Explore the Getting Started Guide to personalize your site to suit your needs.', 'automotive-parts' ); ?></p>
                            <p><a class="info-link button" href="<?php echo esc_url( admin_url( 'themes.php?page=automotive-parts-getstart-page' ) ); ?>"><?php esc_html_e( 'View Getting Started Guide', 'automotive-parts' ); ?></a></p>
                        </div>
                    </div>
                </div>
            </div>

            <?php
        }

    }
}

add_action( 'admin_notices', 'automotive_parts_admin_notice' );

if( ! function_exists( 'automotive_parts_update_admin_notice' ) ) :
/**
 * Updating admin notice on dismiss
*/
function automotive_parts_update_admin_notice(){
    if ( isset( $_GET['automotive_parts_admin_notice'] ) && $_GET['automotive_parts_admin_notice'] = '1' ) {
        update_option( 'automotive_parts_admin_notice', true );
    }
}
endif;
add_action( 'admin_init', 'automotive_parts_update_admin_notice' );

add_action('after_switch_theme', 'automotive_parts_setup_options');
function automotive_parts_setup_options () {
    update_option('automotive_parts_admin_notice', FALSE );
}

// changelog
function automotive_parts_get_changelog_from_readme() {
    $automotive_parts_file_path = get_template_directory() . '/readme.txt'; // Adjust path if necessary

    if (file_exists($automotive_parts_file_path)) {
        $automotive_parts_content = file_get_contents($automotive_parts_file_path);

        // Extract changelog section
        $automotive_parts_changelog_start = strpos($automotive_parts_content, "== Changelog ==");
        $automotive_parts_changelog = substr($automotive_parts_content, $automotive_parts_changelog_start);

        // Split changelog into versions
        preg_match_all('/\*\s([\d\.]+)\s-\s(.+?)\n((?:\t-\s.+?\n)+)/', $automotive_parts_changelog, $automotive_parts_matches, PREG_SET_ORDER);
        
        return $automotive_parts_matches;
    }
    return [];
}